//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                           e-PSI@Multi_Scalper.mq4 |
//|                                       Copyright  2012, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|                                                                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  - |
//|      (TarasBY).    - |
//|      ,    .  - |
//|      .                                 |
//|         ,    - |
//| .                                                             |
//|     ,     ,    |
//|     Skype: TarasBY  e-mail.                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define UP    0
#define DW    1
#define STOP -1
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                   *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string SETUP_Expert          = "==========    ==========";
extern int    MG                       = 2012;
extern int    NewBarInPeriod           = 1;                // >= 0 -      , -1 -    
#include      <b-PSI@Base.mqh>                             //   
#include      <b-PSI@MULTI_Light.mqh>                      //      
#include      <b-PSI@STOPs_Light.mqh>                      //     
extern string SETUP_RulesClose      = "---------------- RULES`s CLOSE ----------------";
extern bool   CloseInverseSignal       = FALSE;            //    
extern int    NBars_LifeMIN            = 0;                //  ""   NBars_LifeMIN   TF_Indicator 
extern int    NBars_LifeMAX            = -1;               //  ""   NBars_LifeMAX   TF_Indicator  (0 -      )
extern string SETUP_Indicator       = "=============== Setup Indicator ===============";
extern int    TF_Indicator             = 60;               //  
/*extern*/ int    FilterPeriod             = 22;
/*extern*/ int    SL_distance_pips         = 20;
extern int    BarControl               = 4;                // >= 2 -      
extern double LevelControl             = 0.8;              // <= 1 -   
extern double Popravka                 = 0.3;              // <= 1 -    
//IIIIIIIIIIIIIIIIIII========== ==========IIIIIIIIIIIIIIIIIIIIII+
#include      <b-PSI@Trail_Stairs.mqh>                     //    ()
#include      <b-PSI@ManagerPA.mqh>                        //      
#include      <b-PSI@MM_Light.mqh>                         //   
#include      <b-PSI@Services_Light.mqh>                   //   
#include      <b-PSI@Trade_Light.mqh>                      //    
//IIIIIIIIIIIIIIIIIII======  ======IIIIIIIIIIIIIIIIIIIIII+
double        gda_Point[];
int           gia_MyOrders[][3], gia_HistoryOrders[3],
              gia_Digits[], gia_MyOrd[2];
string        gs_Info;
datetime      gdt_NewBarIndicator;
bool          gb_VirtSTOPs;                                //      
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{
    int li_Period, err = GetLastError();
//----
    //----      
    if (!fCheck_ExternParameters()) {bb_OptimContinue = true; return (0);}
    //----    
    fInit_Base (Symbol(), MG, TF_Indicator, ShowCommentInChart, PrintCom, SoundAlert, CreatVStopsInChart);
    //----     
    if (!fInit_ManagerPA()) return (0);
    //----   
    if (!fInit_STOPs()) return (0);
    //----   
    if (!fInit_Trail()) return (0);
    //----   
    fGet_Statistic (-1);
    //----   MM
    bd_LotsMM = fInit_MM (Order_Lots, MG);
    //----      
    if (!bb_RealTrade) {Symbol_List = Symbol();}
    //----        
    fWork_MULTI();
    ArrayResize (gia_MyOrders, bi_cntSMB);
    ArrayResize (gda_Point, bi_cntSMB);
    ArrayResize (gia_Digits, bi_cntSMB);
    //----      
    bdt_BeginTrade = fGet_TermsTrade (bs_SymbolList, MG, bdt_LastTrade);
    bs_ExpertName = StringConcatenate (WindowExpertName(), ":  ", fGet_NameTF (Period()), " | S-", bi_cntSMB);
    //----    
    for (int li_IND = 0; li_IND < bi_cntSMB; li_IND++)
    {
        gda_Point[li_IND] = MarketInfo (bsa_SMB[li_IND], MODE_POINT);
        gia_Digits[li_IND] = MarketInfo (bsa_SMB[li_IND], MODE_DIGITS);
    }
    gb_VirtSTOPs = USE_VirtualSTOPs || VirtualTrail_ON;
   //----   
    fGet_LastErrorInArray (bsa_Comment, "init()", bi_indERR);
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor expert deinitialization function                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
//----
    fMineDeInit();
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom expert iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
    //----    "" 
    if (fSet_Continue()) return (0);
    bdt_BeginNewBar = iTime (Symbol(), TF_Indicator, 0);
//----
    int err = GetLastError();
//----
    //----  "" 
    bi_MyOrders = fMyPositions (bd_ProfitCUR, gia_MyOrders, bsa_SMB, MG);
    //----  
    fGet_Statistic (PERIOD_D1);
    //----     ( )
    if (ShowCommentInChart) {fCommentInChart (bsa_Comment, fGet_StringManagerPA());}
    //----     TF 
    if (gdt_NewBarIndicator == bdt_BeginNewBar) {return (0);}
    //----      ( NewBarInPeriod >= 0)
    if (!fCheck_NewBarInPeriod (NewBarInPeriod)) return (0);
    //----        
    if (fManagerPA (bd_ProfitCUR, bd_Balance, bi_MyOrders > 0)) {bi_MyOrders = 0;}
    else
    {
        //----      
        for (int li_SMB = 0; li_SMB < bi_cntSMB; li_SMB++)
        {fControl_Symbol (bsa_SMB[li_SMB], li_SMB);}
        //----      
        if (bi_MyOrders > 0) {if (!bb_TSProfit) fControl_Positions (bs_SymbolList, MG);}
    }
    //----     
    if (bi_MyOrders == 0) gdt_NewBarIndicator = bdt_BeginNewBar;
    //----   
    fGet_LastErrorInArray (bsa_Comment, "start()", bi_indERR);
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string fGet_OrderComment (int fi_Type)
{return (StringConcatenate (EXP_Comment, " | ", fGet_NameOP (fi_Type), " | ", bi_MyOrders + 1));}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_Signal (string fs_Symbol, int fi_Bar = 5)
{
    double ld_Signal_0 = iCustom (fs_Symbol, TF_Indicator, "scalping future", FilterPeriod, SL_distance_pips, BarControl, LevelControl, True, 0, 1),
           ld_Signal_Bar = iCustom (fs_Symbol, TF_Indicator, "scalping future", FilterPeriod, SL_distance_pips, BarControl, LevelControl, True, 0, fi_Bar);
    int    li_Signal = STOP;
//----
    if (ld_Signal_Bar <= -LevelControl && ld_Signal_0 > Popravka - LevelControl) li_Signal = UP; //up
    if (ld_Signal_Bar >= LevelControl && ld_Signal_0 < LevelControl - Popravka) li_Signal = DW;  //down
//----
    return (li_Signal);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|            (fs_Symbol)                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fControl_Symbol (string fs_Symbol,          // Symbol
                      int fi_IND)                //     bsa_SMB[]
{
    int li_Signal = fGet_Signal (fs_Symbol, BarControl);
//----
    if (li_Signal < 0) return;
    int li_cmd, li_Ticket;
    if (gia_MyOrders[fi_IND][2] == 0)
    {
        RefreshRates();
        if (li_Signal == 0) li_cmd = 1; else li_cmd = 0;
        double ld_Price = NormalizeDouble (fGet_TradePrice (li_cmd, bb_RealTrade, fs_Symbol), gia_Digits[fi_IND]);
        bd_LotsMM = fGet_SizeLot (Order_Lots, bd_BaseBalance, li_Signal, fs_Symbol, MG);
        if (bd_LotsMM > 0.0)
        {li_Ticket = fOrderSend (fs_Symbol, li_Signal, bd_LotsMM, ld_Price, Slippage, 0.0, 0.0, fGet_OrderComment (li_Signal), MG);}
        if (li_Ticket > 0) bi_MyOrders++;
    }
    else
    {
        if (!CloseInverseSignal || bb_TSProfit) return;
        double ld_Pribul;
        if (li_Signal == 0) li_cmd = 1; else li_cmd = 0;
        if (gia_MyOrders[fi_IND][li_cmd] > 0)
        {if (fClose_AllOrders (fs_Symbol, MG, ld_Pribul, li_cmd, NBars_LifeMIN) > 0) bi_MyOrders--;}
    }
//----
    return;
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          ""                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fMyPositions (double& fd_Profit,          //     
                  int& ar_MyOrders[][],       //      
                  string ar_Symbols[],        //    
                  int fi_Magic = -1)          // Magic
{
    int    li_total = OrdersTotal(), li_Ord = 0, li_ind_SMB;
//----
    //fMyPositions (gd_Profit, gia_MyOrders, bsa_SMB, MG);
    ArrayInitialize (ar_MyOrders, 0);
    ArrayInitialize (gia_MyOrd, 0);
    fd_Profit = 0.0;
    if (li_total == 0) {return (0);}
    for (int li_pos = li_total - 1; li_pos >= 0; li_pos--)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
        li_ind_SMB = fGet_INDInArraySTR (OrderSymbol(), ar_Symbols);
        if (li_ind_SMB < 0) continue;
        if (OrderMagicNumber() != fi_Magic) {if (fi_Magic >= 0) continue;}
        if (OrderType() > 1) continue;
        fd_Profit += (OrderProfit() + OrderSwap() + OrderCommission());
        ar_MyOrders[li_ind_SMB][2]++;
        ar_MyOrders[li_ind_SMB][OrderType()]++;
        gia_MyOrd[OrderType()]++;
        li_Ord++;
    }
//----
    return (li_Ord);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//              .                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCheck_ExternParameters()
{
//----
    //----   GV- 
    bs_NameGV = StringConcatenate ("MScalper[", MG, "]");
    //----    
    if (BarControl < 1) {Print (" BarControl >= 1 !!!"); return (false);}
    if (LevelControl > 1.0 || LevelControl < 0.5) {Print (" 0.5 <= LevelControl <= 1.0 !!!"); return (false);}
    if (Popravka > 0.4 || Popravka < 0.0) {Print (" 0.0 <= Popravka <= 0.4 !!!"); return (false);}
    if (TF_Indicator == 0) TF_Indicator = Period();
    if (NewBarInPeriod == 0) NewBarInPeriod = Period();
    if (CloseInverseSignal) if (NBars_LifeMIN == 0)
    {Alert ("    .  NBars_LifeMIN > 0 ",
    "\n        CloseInverseSignal = False"); return (false);}
    //----       
    if (EXP_Comment == "") EXP_Comment = StringSubstr (WindowExpertName(), StringFind (WindowExpertName(), "@") + 1);
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fMineDeInit()
{
//----
    if (!bb_RealTrade) GlobalVariablesDeleteAll (bs_NameGV);
    //----   ( )    
    if (bb_VirtualTrade) return (0);
    //----    
    if (ClearALLAfterTrade)
    {
        Comment ("");
        //----      
        fObjectsDeleteAll ("sculpF", -1, -1); 
        //----      
        fObjectsDeleteAll (bs_NameGV, -1, -1); 
        //----  GV-
        GlobalVariablesDeleteAll (bs_NameGV);
    }
    else
    {
        if (ShowCommentInChart)
        {
            //----   
            fGet_Statistic (-1);
            //----    
            fCommentInChart (bsa_Comment, fGet_StringManagerPA());
        }
    }
    if (ObjectFind ("STOP") == 0) ObjectDelete ("STOP");
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                            |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|         ""                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fControl_Positions (string fs_SymbolList,        //    
                         string fs_MagicList,         //   
                         string fs_Delimiter = ",")   //     fs_MagicList
{
    int    li_Ticket, err = GetLastError(), li_LifeBar;
    string ls_Symbol;
    bool   lb_NewBar = false;
    static datetime ldt_NewBar = 0;
    datetime ldt_BeginBar = iTime (NULL, TF_STOPs, 0);
//----
    if (ldt_NewBar != ldt_BeginBar) lb_NewBar = true;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        ls_Symbol = OrderSymbol();
        if (StringLen (fs_SymbolList) > 0) {if (StringFind (fs_SymbolList, ls_Symbol) < 0) continue;}
        if (!fCheck_MyMagic (fs_MagicList, fs_Delimiter)) continue;
        if (OrderType() > 1) continue;
        li_Ticket = OrderTicket();
        //----     
        fGet_MarketInfo (bs_Symbol);
        li_LifeBar = iBarShift (Symbol(), TF_Indicator, OrderOpenTime());
        //----      
        if (fControl_MAXLife (li_LifeBar, NBars_LifeMAX)) continue;
        //----    
        if (Virtual_Order_SL != 0 || Virtual_Order_TP != 0 || USE_VirtualSTOPs)
        {
            //----  "" 
            if ((NBars_LifeMIN > 0 && NBars_LifeMIN < li_LifeBar) || NBars_LifeMIN == 0)
            {if (fVirtualSTOPs (li_Ticket, Virtual_Order_SL, Virtual_Order_TP, Slippage, USE_Dinamic_TP)) continue;}
        }
        //----   
        if (lb_NewBar || !GlobalVariableCheck (StringConcatenate (li_Ticket, "_#STOP")))
        {if (fCreat_STOPs (N_STOPs, li_Ticket, bda_Price[OrderType()], TF_STOPs, gb_VirtSTOPs)) continue;}
        //----   
        fTrail_Position (li_Ticket, Slippage);
    }
    if (lb_NewBar) ldt_NewBar = ldt_BeginBar;
    //----   
    fGet_LastErrorInArray (bsa_Comment, "fControl_Positions()", bi_indERR);
//----
    return;
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                           |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCommentInChart (string& ar_Comment[],      //   
                      string fs_ManagerPA = "")  //        
{
    static string lsa_Time[], lsa_Comment[], ls_BeginTrade, ls_Conditions,
                  ls_row = "\n",
                  ls_PSI = " PSITarasBY \n";
    static bool   lb_first = true;
    static int    li_size, li_size_CommTime, li_Period = 60;
    string ls_CTRL = "", ls_BLOCK_Comment, ls_Comment = "", ls_TermsTrade,
           ls_Error = "", ls_time = "", ls_sign;
//----
    //----      
    if (lb_first)
    {
        li_Period *= NewBarInPeriod;
        li_size = ArraySize (ar_Comment);
        ArrayResize (lsa_Time, li_size);
        ArrayResize (lsa_Comment, li_size);
        InitializeArray_STR (lsa_Comment, "");
        InitializeArray_STR (lsa_Time, "");
        ls_BeginTrade = StringConcatenate ("Terms Trade :: Begin - ", TimeToStr (bdt_BeginTrade));
        ls_Conditions = StringConcatenate ("NewBarInPeriod - ", fGet_NameTF (NewBarInPeriod), " | TF Indicators - ", fGet_NameTF (TF_Indicator),
        "\nCloseInverseSignal - ", CheckBOOL (CloseInverseSignal), " | VirtualSTOPs - ", CheckBOOL (USE_VirtualSTOPs),
        "\nDinamic SL - ", CheckBOOL (USE_Dinamic_SL), " | Dinamic TP - ", CheckBOOL (USE_Dinamic_TP), "\n");
        gdt_NewBarIndicator = iTime (Symbol(), TF_Indicator, 1);
        bdt_NewBarInPeriod = iTime (Symbol(), NewBarInPeriod, 0);
        lb_first = false;
    }
    //----  
    for (int li_MSG = 0; li_MSG < li_size; li_MSG++)
    {
        //----    
        if (StringLen (ar_Comment[li_MSG]) > 0)
        {
            if (ar_Comment[li_MSG] != lsa_Comment[li_MSG])
            {lsa_Comment[li_MSG] = ar_Comment[li_MSG];}
            if (li_MSG == li_size - 1) {ls_sign = "";} else {ls_sign = " : ";}
            lsa_Time[li_MSG] = StringConcatenate (TimeToStr (bdt_curTime), ls_sign);
            ar_Comment[li_MSG] = "";
        }
        //----   
        if (li_MSG < li_size - 1)
        {if (StringLen (lsa_Comment[li_MSG]) > 0) {ls_Comment = StringConcatenate (ls_Comment, lsa_Time[li_MSG], lsa_Comment[li_MSG], "\n");}}
        //----   
        else if (li_MSG == li_size - 1)
        {
            //----  2     
            if (bdt_curTime > StrToTime (lsa_Time[li_MSG]) + 7200)
            {lsa_Comment[li_MSG] = "";}
            if (StringLen (lsa_Comment[li_MSG]) > 0) {ls_Error = StringConcatenate (ls_row, "ERROR:  ", lsa_Time[li_MSG], "\n", lsa_Comment[li_MSG]);}
        }
    }
    //----      
    ls_time = StringConcatenate ("\nTime :: cur ", TimeToStr (bdt_curTime, TIME_DATE|TIME_SECONDS), " | local ", TimeToStr (TimeLocal(), TIME_MINUTES|TIME_SECONDS));
    if (NewBarInPeriod > 0) {ls_time = StringConcatenate (TimeToStr (bdt_NewBarInPeriod + li_Period), " | ", TimeToStr (gdt_NewBarIndicator + TF_Indicator * 60), ls_time);}
    ls_TermsTrade = StringConcatenate (ls_BeginTrade, " | Last - ", TimeToStr (bdt_LastTrade), "\n");
    //----    
    ls_BLOCK_Comment = StringConcatenate (bs_ExpertName, "\n", ls_row, gs_Info, ls_time, "\n",
                 ls_TermsTrade,
                 ls_Conditions,
                 ls_row,
                 //----   
                 "          PROFIT    = ", bs_sign, " ", fSplitField (DoubleToStr (bd_ProfitCUR, 1)), " | ", DoubleToStr (bd_ProfitPercent - 100.0, 1), " % [ ", bi_MyOrders, " | ", gia_MyOrd[0], " / ", gia_MyOrd[1], " ]\n",
                 //----     
                 fs_ManagerPA,
                 "          RESULT    = ", bs_sign, " ", fSplitField (DoubleToStr (bd_Pribul, 1)), " [ ", fSplitField (gia_HistoryOrders[2]), " | ", fSplitField (gia_HistoryOrders[0]), " / ", fSplitField (gia_HistoryOrders[1]), " ]\n",
                 ls_PSI,
                 //----  
                 ls_Comment,
                 //----  
                 ls_Error);//,
    //----      
    Comment (ls_BLOCK_Comment);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fGet_Statistic (int fi_Period = 0,           //   (TF)    
                     bool fb_IsTimeGMT = false)   //   
{
    static datetime ldt_NewBar = 0;
    static int li_PreHistOrders = 0;
    int      li_ORD, err = GetLastError(), li_Period =  MathMax (0, fi_Period);
    string   ls_Symbol = Symbol();
    datetime ldt_NewPeriod = iTime (ls_Symbol, li_Period, 0);
//----
    //----    " "
    bdt_curTime = TimeCurrent();
    bd_Balance = AccountBalance();
    bd_Equity = AccountEquity();
    bd_FreeMargin = AccountFreeMargin();
    bd_Margin = AccountMargin();
    if (li_PreHistOrders != OrdersHistoryTotal() || ldt_NewBar != ldt_NewPeriod || fi_Period < 0)
    {
        li_PreHistOrders = OrdersHistoryTotal();
        ldt_NewBar = ldt_NewPeriod;
        //----   
        bd_Pribul = fCalculate_Pribul (gia_HistoryOrders, Symbol_List, MG);
    }
    //----        
    fCheckInfo();
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "fGet_Statistic()", bi_indERR);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCheckInfo()
{
    static double ld_pre_Lot = 0.0;
//----
    if (ShowCommentInChart)
    {
        if (ld_pre_Lot != bd_LotsMM)
        {
            string ls_Trail = "", ls_MM, ls_addConditions;
            ls_MM = IIFs (UseMM, StringConcatenate ("MM (", DSDig (bd_LotsMM), ")", fGet_MeansType (MeansType, LotsPercent)), "L: " + DSDig (bd_LotsMM));
            ls_addConditions = StringConcatenate (IIFs ((StringLen (ls_Trail) > 0), ls_Trail, ""),
            IIFs ((StringLen (ls_MM) > 0), " - ", ""),
            IIFs ((StringLen (ls_MM) > 0), ls_MM, ""));
            //----  " - "    ( )
            ls_addConditions = IIFs ((StringFind (ls_addConditions, " - ") == 0), StringSubstr (ls_addConditions, 3), ls_addConditions);
            //----   
            gs_Info = StringConcatenate (bs_NameGV, ":     STOP`s", " [ ", StopLoss, "/", TakeProfit, " | ", Virtual_Order_SL, "/", Virtual_Order_TP, " ]", "\n",
            IIFs ((StringLen (ls_addConditions) > 0), StringConcatenate (ls_addConditions, "\n"), ""),
            "Lots: MIN = ", DSDig (bd_MINLOT), " | MAX = ", DSDig (bd_MAXLOT), " | STEP = ", bd_LOTSTEP, "\n",
            IIFs ((NewBarInPeriod < 0), "   ", " : "));
            ld_pre_Lot = bd_LotsMM;
        }
    }
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| : TESTER                                                                    |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|           ""                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fSet_Continue()
{
    static bool lb_Continue = true;
//----
    if (!bb_RealTrade)
    {
        //----     ()
        if (NewBarInPeriod >= 0) if (iTime (bs_Symbol, NewBarInPeriod, 0) == 0)
        {fPrintAlert (bs_Symbol, NewBarInPeriod, 0); return (true);}
        if (iTime (bs_Symbol, TF_Indicator, 0) == 0)
        {fPrintAlert (bs_Symbol, TF_Indicator, 1); return (true);}
    }
    //----     
    if (!lb_Continue) return (false);
    if (IsOptimization())
    {
        if (bb_OptimContinue) return (true);
        if (fGet_NumPeriods (TF_Indicator) < 0) {bb_OptimContinue = true; return (true);}
        if (fGet_NumPeriods (NewBarInPeriod) < 0) {bb_OptimContinue = true; return (true);}
    }
    else {if (fSTOPTRADE()) return (true);}
    lb_Continue = false;
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

