//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                                b-PSI@MM_Light.mqh |
//|                                       Copyright  2012, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//| 11.04.2012     ().                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  - |
//|      (TarasBY).    - |
//|      ,    .  - |
//|      .                                 |
//|         ,    - |
//| .                                                            |
//|     ,    ,    |
//|     Skype: TarasBY  e-mail.                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                 *****                  *****                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string Setup_Lots            = "========     ========";
extern bool   UseMM                    = TRUE;             //   
extern string LotsWayChoice.0_2        = "0-.; 1-%  MeansType; 2- ATR";
extern int    LotsWayChoice            = 1;                //    :
extern string MeansType.1_3            = "1-Balance; 2-Equity; 3-FreeMargin";
extern int    MeansType                = 1;                //  ,     :
extern double Order_Lots               = 0.1;              //   
extern double LotsPercent              = 5.0;              //   MeansType
extern double K_Lots                   = 2;                //      
extern double MinLot                   = 0.01;             //    
extern double MaxLot                   = 5.0;              //     
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIII========  =======IIIIIIIIIIIIIIIIIIIIII+
double        bi_factor = 1;
bool          bb_IsOpenOrders;                             //    
//IIIIIIIIIIIIIIIIIII===========  =========IIIIIIIIIIIIIIIIIIIIII+
/*double fInit_MM (double fd_Lots,                         // Lots
                   int fi_Magic = -1)*/                    // Magic
                                     //  
/*double fGet_SizeLot (double fd_Lot,                      //   
                       double fd_BaseBalance,              //   + BaseBalance
                       int fi_Type,                        //   
                       string fs_SymbolList = "",          //    
                       string fs_MagicList = "",           //    
                       bool fb_IsNET = false)*/            //    
                                     //   
/*string fGet_MeansType (int fi_Variant,                   //   
                         int fi_Percent)*/                 //  ( )
                                     //        
/*double fCalculate_Pribul (int& ar_HistoryOrders[3],      //        
                            string fs_SymbolList,          //    
                            string fs_MagicList,           //   
                            int fi_OP = -1,                //  (BUY\SELL)  
                            datetime fdt_TimeBegin = 0,    //  ,    
                            string fs_Comment = "",        //  
                            string fs_Delimiter = ",")*/   //     fs_MagicList
                                    //      
/*void fClear_WasteGV (string ar_NameGV[],                 //     GV-
                       string fs_Ticket)*/                 // Ticket
                                    //     GV-
//int fGet_hildTicket (string fs_Comment)
                                    //  Ticket  
//double fLotCostCurrency (string fs_Symbol)
                                    //       
/*double fGet_PriceLastOrder (int fi_MG,                   // OrderMagicNumber()
                              int fi_Type,                 // OrderType()
                              double& fd_Lot)*/            //   OrderLots()
                                     //       
//double fGet_PriceSymbol (string fs_Symbol)
                                     //       
//int fGet_NSeries (string fs_Comment)
                                     //        
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| : MONEY MANAGEMENT                                                          |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fInit_MM (double fd_Lots,             // Lots
                 int fi_Magic = -1)          // Magic
{
//----
    if (bi_Decimal == 1) bi_factor = 10;
    MinLot = fLotsNormalize (MinLot);
    //----     
    if (MaxLot > bd_MAXLOT) bb_MMM = true;
    MaxLot = fLotsNormalize (MaxLot);
    double ld_Lots = fLotsNormalize (fd_Lots);
    Print ("Lots = ", DSDig (ld_Lots), " |  = ", AccountLeverage(), " | MIN Lot = ", DSDig (bd_MINLOT), " | MAX Lot = ", DSDig (bd_MAXLOT));
    ld_Lots = fGet_SizeLot (Order_Lots, bd_BaseBalance, OP_BUY, Symbol(), fi_Magic);
    bd_preLotsPercent = LotsPercent;
//----
    return (ld_Lots);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_SizeLot (double fd_Lot,                     //   
                     double fd_BaseBalance,             //  
                     int fi_Type = 0,                   //   
                     string fs_SymbolList = "",         //    
                     string fs_MagicList = "",          //    
                     bool fb_IsNET = false)             //    
{
    //----  MM   - 
    if (!UseMM) {return (fLotsNormalize (fd_Lot));}
    double ld_Lots, Money = 0;
    string ls_Symbol, ls_fName = "fGet_SizeLot()";
//----
    if (StringFind (fs_SymbolList, bs_Delimiter) > 0) ls_Symbol = bs_Symbol;
    else ls_Symbol = fs_SymbolList;
    if (!fb_IsNET)
    {
        switch (MeansType)
        {
            case 2: Money = bd_Equity; break;
            case 3: Money = bd_FreeMargin; break;
            default: Money = bd_Balance; break;
        }
        switch (LotsWayChoice)
        {
            case 1: //    
                if (MeansType == 3)
                {ld_Lots = (Money * LotsPercent) / (MarketInfo (ls_Symbol, MODE_MARGINREQUIRED) * 100.0);}
                else {ld_Lots = (Money * LotsPercent) / 100000.0;}
                break;
            case 2:
                double ld_ATR = iATR (ls_Symbol, Period(), 20, 1);
                if (ld_ATR != 0.0) {ld_Lots = NDP (Money * 0.001 / ld_ATR);}
                break;
            default: ld_Lots = fd_Lot; break;
        }
    }
    //----      
    else
    {
        bi_LastType = -1;
        //----     
        bd_LastPrice = fGet_PriceLastOrder (fs_SymbolList, fs_MagicList, bi_LastType, ld_Lots);
        bd_LastLots = ld_Lots;
        if (K_Lots > 0) ld_Lots *= K_Lots;
    }
    double ld_LotCost = fLotCostCurrency (ls_Symbol);
    fSet_Comment (bi_curOrdersInSeries, 0, 2, "fLotCostCurrency()", True, ld_Lots, ld_LotCost);
    if (ld_LotCost > 0.0) ld_Lots /= ld_LotCost;
    ld_Lots = MathMax (ld_Lots, MinLot);
    if (ld_Lots > MaxLot) fSet_Comment (bi_curOrdersInSeries, 0, 7, ls_fName, False, ld_Lots, MaxLot);
    ld_Lots = MathMin (ld_Lots, MaxLot);
    //----   
    fGet_LastErrorInArray (bsa_Comment, ls_fName, bi_indERR);
//----
    return (fLotsNormalize (ld_Lots));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string fGet_MeansType (int fi_Variant,      //   
                       double fd_Percent)   //  ( )
{
//----
    if (LotsWayChoice > 0)
    {
        switch (LotsWayChoice)
        {
            case 1:
                string ls_cause = StringConcatenate (" at ", DoubleToStr (fd_Percent, 1), "% ");
                switch (fi_Variant)
                {
                    case 2: return (StringConcatenate (": ", ls_cause, "from Equity = ", bs_sign, fSplitField (DoubleToStr (bd_Equity, 1))));
                    case 3: return (StringConcatenate (": ", ls_cause, "from FreeMargin = ", bs_sign, fSplitField (DoubleToStr (bd_FreeMargin, 1))));
                    default: return (StringConcatenate (": ", ls_cause, "from Balance = ", bs_sign, fSplitField (DoubleToStr (bd_Balance, 1))));
                }
            case 2: return (": from ATR");
        }
    }
//----
    return ("");
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fCalculate_Pribul (int& ar_HistoryOrders[3],    //        
                          string fs_SymbolList,        //    
                          string fs_MagicList,         //   
                          int fi_OP = -1,              //  (BUY\SELL)  
                          datetime fdt_TimeBegin = 0,  //  ,    
                          string fs_Comment = "",      //  
                          string fs_Delimiter = ",")   //     fs_MagicList
{
    double   ld_Pribul = 0.0;
    int      li_Type, err = GetLastError(), history_total = OrdersHistoryTotal(),
             li_ChildTicket, li_Ticket;
    string   ls_Name, ls_NameChild;
    datetime ldt_preLastTrade = bdt_LastTrade - 2 * 10080 * 60;
    static string lsa_NameGV[] = {"_#VirtSL","_#VirtTP","_#BU","_#STOP"};
//----
    ArrayInitialize (ar_HistoryOrders, 0);
    for (int li_ORD = 0; li_ORD < history_total; li_ORD++)
    {
        if (!OrderSelect (li_ORD, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (StringLen (fs_SymbolList) > 0) {if (StringFind (fs_SymbolList, OrderSymbol()) < 0) continue;}
        if (!fCheck_MyMagic (fs_MagicList, fs_Delimiter)) continue;
        li_Type = OrderType();
        if (li_Type > 1) continue; else {if (fi_OP > -1) if (li_Type != fi_OP) continue;}
        if (fdt_TimeBegin > OrderOpenTime()) continue;
        if (fs_Comment != "") {if (StringFind (OrderComment(), fs_Comment) < 0) continue;}
        ld_Pribul += (OrderProfit() + OrderSwap() + OrderCommission());
        ar_HistoryOrders[2]++;
        ar_HistoryOrders[OrderType()]++;
        if (bdt_LastTrade < OrderCloseTime()) bdt_LastTrade = OrderCloseTime();
        //----     
        if (iBarShift (Symbol(), bi_TFControl, OrderCloseTime()) == 0) {bdt_NewBar = bdt_BeginNewBar;}
        //----     GV- 
        if (fs_Comment != "") continue;
        //----   GV-   2-
        if (!bb_ClearGV) continue;
        if (ldt_preLastTrade < OrderCloseTime())
        {
            li_Ticket = OrderTicket();
            li_ChildTicket = fGet_hildTicket (OrderComment());
            //----    ,    
            if (li_ChildTicket > 0)
            {
                if (OrderSelect (li_ChildTicket, SELECT_BY_TICKET))
                {
                    if (OrderCloseTime() == 0)
                    {
                        for (int li_GV = 0; li_GV < 4; li_GV++)
                        {
                            //----       
                            ls_Name = StringConcatenate (li_Ticket, lsa_NameGV[li_GV]);
                            if (GlobalVariableCheck (ls_Name))
                            {
                                ls_NameChild = StringConcatenate (li_ChildTicket, lsa_NameGV[li_GV]);
                                if (!GlobalVariableCheck (ls_Name))
                                {GlobalVariableSet (ls_NameChild, GlobalVariableGet (ls_Name));}
                            }
                        }
                        continue;
                    }
                }
            }
            fClear_WasteGV (bsa_prefGV, li_Ticket);
        }
    }
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "fCalculate_Pribul()", bi_indERR);
//----
    return (ld_Pribul);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|            GV-                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fClear_WasteGV (string ar_NameGV[],  //     GV-
                     string fs_Ticket)    // Ticket
{
    string ls_Name;
    static int li_size = 0;
    static bool lb_first = true;
//---- 
    if (lb_first) {li_size = ArraySize (ar_NameGV); lb_first = false;}
    for (int li_IND = 0; li_IND < li_size; li_IND++)
    {
        ls_Name = StringConcatenate (fs_Ticket, ar_NameGV[li_IND]);
        if (GlobalVariableCheck (ls_Name)) GlobalVariableDel (ls_Name);
    }
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|         Ticket                                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_hildTicket (string fs_Comment)
{
    int li_N1 = StringFind (fs_Comment, "to");
//----
    if (li_N1 >= 0)
    {
        int li_N2 = StringFind (fs_Comment, "#");
        if (li_N2 > li_N1)
        {return (StrToInteger (StringSubstr (fs_Comment, li_N2 + 1, StringLen (fs_Comment) - li_N2 - 1)));}
    }
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fLotCostCurrency (string fs_Symbol)
{
    string ls_FirstPart = StringSubstr (fs_Symbol, 0, 3),
           ls_SecondPart = StringSubstr (fs_Symbol, 3, 3),
           ls_Pref = StringSubstr (fs_Symbol, 6),
           ls_Currency = AccountCurrency();
    double ld_Cost = -1.0, ld_Base = NDP (MarketInfo (fs_Symbol, MODE_LOTSIZE)) / bi_factor;
//----
    if (ls_SecondPart == ls_Currency) {ld_Cost = ld_Base;}
    else
    {
        double ld_Price = fGet_PriceSymbol (fs_Symbol);
        if (ls_FirstPart == ls_Currency) {if (ld_Price > 0) ld_Cost = ld_Base / ld_Price;}
        else
        {
            ld_Price = fGet_PriceSymbol (StringConcatenate (ls_Currency, ls_SecondPart, ls_Pref));
            if (ld_Price > 0) {ld_Cost = ld_Base / ld_Price;}
            else
            {
                ld_Price = fGet_PriceSymbol (StringConcatenate (ls_SecondPart, ls_Currency, ls_Pref));
                if (ld_Price > 0) {ld_Cost = ld_Base * ld_Price;}
            }
        }
    }
    GetLastError();
//----
    return (NDDig (ld_Cost));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_PriceLastOrder (string fs_SymbolList,   //    
                            string fs_MagicList,    //   
                            int& fi_Type,           // OrderType()
                            double& fd_Lot)         //   OrderLots()
{
    datetime ldt_OpenTime = 0;
    double   ld_OpenPrice = 0.0;
    int      li_Type, li_Ticket, err = GetLastError();
    string   ls_Com = "";
//----
    for (int li_ORD = OrdersTotal() - 1; li_ORD >= 0; li_ORD--)
    {
        if (!OrderSelect (li_ORD, SELECT_BY_POS)) continue;
        if (StringLen (fs_SymbolList) > 0) {if (StringFind (fs_SymbolList, OrderSymbol()) < 0) continue;}
        if (!fCheck_MyMagic (fs_MagicList)) continue;
        li_Type = OrderType();
        if (li_Type > 1) continue; else {if (fi_Type > -1) if (li_Type != fi_Type) continue;}
        if (ldt_OpenTime < OrderOpenTime())
        {
            ldt_OpenTime = OrderOpenTime();
            li_Ticket = OrderTicket();
        }
    }
    //----     
    if (OrderSelect (li_Ticket, SELECT_BY_TICKET))
    {
        li_Type = OrderType();
        //----     
        if (fi_Type == -1) fi_Type = li_Type;
        ld_OpenPrice = OrderOpenPrice();
        fd_Lot = OrderLots();
        ls_Com = OrderComment();
        //----      
        bi_curOrdersInSeries = fGet_NSeries (ls_Com);
    }
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "fGet_PriceLastOrder()", bi_indERR);
//----
    return (ld_OpenPrice);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_PriceSymbol (string fs_Symbol)
{
//----
    if (bb_RealTrade) return (MarketInfo (fs_Symbol, MODE_BID));
    else
    {
        int li_Bar = iBarShift (fs_Symbol, 1, TimeCurrent());
        return (iOpen (fs_Symbol, 1, li_Bar));
    }
//----
    return (0.0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_NSeries (string fs_Comment)
{
    int li_N = StringFind (fs_Comment, "|| ");
//----
    if (li_N >= 0) {return (StrToInteger (StringSubstr (fs_Comment, li_N + 3)));}
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

